searchData={"items":[{"type":"module","title":"Claude","doc":"Opinionated Claude Code integration for Elixir projects.\n\nA Claude that writes code like an experienced Elixir developer.","ref":"Claude.html"},{"type":"module","title":"Our Opinions - Claude","doc":"1. Code should always be production-ready\n2. Project-scoped by default\n3. Zero configuration","ref":"Claude.html#module-our-opinions"},{"type":"module","title":"Installation - Claude","doc":"Add `claude` to your dependencies:\n\n    def deps do\n      [\n        {:claude, \"~> 0.1.0\"}\n      ]\n    end","ref":"Claude.html#module-installation"},{"type":"module","title":"Usage - Claude","doc":"Install Claude hooks (one time per project):\n\n    mix claude.install\n\nThat's it. Claude will now automatically:\n- Format every Elixir file it edits\n- Check for compilation errors after each edit\n\nFor more information, see the [README](https://github.com/bradleygolden/claude).","ref":"Claude.html#module-usage"},{"type":"module","title":"Claude.CLI","doc":"Main CLI entry point for Claude commands.\nSupports nested command structure for extensibility.","ref":"Claude.CLI.html"},{"type":"function","title":"Claude.CLI.main/1","doc":"Main entry point for CLI commands.","ref":"Claude.CLI.html#main/1"},{"type":"module","title":"Claude.CLI.Help","doc":"Displays help information for Claude CLI commands.","ref":"Claude.CLI.Help.html"},{"type":"function","title":"Claude.CLI.Help.run/1","doc":"","ref":"Claude.CLI.Help.html#run/1"},{"type":"module","title":"Claude.CLI.Hooks","doc":"Handles hooks-related CLI commands.","ref":"Claude.CLI.Hooks.html"},{"type":"function","title":"Claude.CLI.Hooks.run/1","doc":"","ref":"Claude.CLI.Hooks.html#run/1"},{"type":"module","title":"Claude.CLI.Hooks.Install","doc":"Handles the installation of Claude Code hooks.","ref":"Claude.CLI.Hooks.Install.html"},{"type":"function","title":"Claude.CLI.Hooks.Install.run/1","doc":"","ref":"Claude.CLI.Hooks.Install.html#run/1"},{"type":"module","title":"Claude.CLI.Hooks.Run","doc":"Handles dynamic hook execution.\nThis is called by Claude Code hooks, not directly by users.\n\nUsage:\n  mix claude hooks run      \n\nExample:\n  mix claude hooks run post_tool_use.elixir_formatter \"Write\" '{\"file_path\": \"lib/foo.ex\"}'","ref":"Claude.CLI.Hooks.Run.html"},{"type":"function","title":"Claude.CLI.Hooks.Run.run/1","doc":"","ref":"Claude.CLI.Hooks.Run.html#run/1"},{"type":"module","title":"Claude.CLI.Hooks.Uninstall","doc":"Handles the uninstallation of Claude Code hooks.","ref":"Claude.CLI.Hooks.Uninstall.html"},{"type":"function","title":"Claude.CLI.Hooks.Uninstall.run/1","doc":"","ref":"Claude.CLI.Hooks.Uninstall.html#run/1"},{"type":"module","title":"Claude.Core.Project","doc":"Project detection and information utilities.\nProvides common functionality for working with Elixir projects.","ref":"Claude.Core.Project.html"},{"type":"function","title":"Claude.Core.Project.claude_path/0","doc":"Returns the path to the .claude directory in the current project.","ref":"Claude.Core.Project.html#claude_path/0"},{"type":"module","title":"Claude.Core.Settings","doc":"Generic settings management for Claude configuration files.\nHandles JSON-based settings that can be used by any feature.","ref":"Claude.Core.Settings.html"},{"type":"function","title":"Claude.Core.Settings.empty?/1","doc":"Checks if settings are effectively empty.","ref":"Claude.Core.Settings.html#empty?/1"},{"type":"function","title":"Claude.Core.Settings.exists?/0","doc":"Checks if the settings file exists.","ref":"Claude.Core.Settings.html#exists?/0"},{"type":"function","title":"Claude.Core.Settings.get/2","doc":"Gets a value from settings using a path of keys.","ref":"Claude.Core.Settings.html#get/2"},{"type":"function","title":"Examples - Claude.Core.Settings.get/2","doc":"get([\"hooks\", \"PostToolUse\"])\n    get([\"memory\", \"auto_update\"], false)","ref":"Claude.Core.Settings.html#get/2-examples"},{"type":"function","title":"Claude.Core.Settings.path/0","doc":"Returns the path to the settings.json file.","ref":"Claude.Core.Settings.html#path/0"},{"type":"function","title":"Claude.Core.Settings.put/2","doc":"Sets a value in settings using a path of keys.","ref":"Claude.Core.Settings.html#put/2"},{"type":"function","title":"Claude.Core.Settings.read/0","doc":"Reads settings from the JSON file.\nReturns {:ok, map} or {:error, reason}.","ref":"Claude.Core.Settings.html#read/0"},{"type":"function","title":"Claude.Core.Settings.remove/0","doc":"Removes the settings file if it exists.","ref":"Claude.Core.Settings.html#remove/0"},{"type":"function","title":"Claude.Core.Settings.update/1","doc":"Updates settings by applying a function to the current settings.","ref":"Claude.Core.Settings.html#update/1"},{"type":"function","title":"Claude.Core.Settings.write/1","doc":"Writes settings to the JSON file.\nCreates the directory structure if needed.","ref":"Claude.Core.Settings.html#write/1"},{"type":"module","title":"Claude.Hooks","doc":"Core hooks functionality including registry and installation.","ref":"Claude.Hooks.html"},{"type":"function","title":"Claude.Hooks.all_hooks/0","doc":"Returns all available hook modules.","ref":"Claude.Hooks.html#all_hooks/0"},{"type":"function","title":"Claude.Hooks.find_hook_by_identifier/1","doc":"Finds a hook module by its identifier.\n\nThe identifier is derived from the module name, e.g.:\n- Claude.Hooks.PostToolUse.ElixirFormatter -> \"post_tool_use.elixir_formatter\"","ref":"Claude.Hooks.html#find_hook_by_identifier/1"},{"type":"function","title":"Claude.Hooks.hook_identifier/1","doc":"Returns the identifier for a hook module.","ref":"Claude.Hooks.html#hook_identifier/1"},{"type":"function","title":"Claude.Hooks.install/0","doc":"Installs all Claude hooks to the project's settings.json.","ref":"Claude.Hooks.html#install/0"},{"type":"function","title":"Claude.Hooks.uninstall/0","doc":"Uninstalls all Claude hooks from the project's settings.json.","ref":"Claude.Hooks.html#uninstall/0"},{"type":"module","title":"Claude.Hooks.Hook","doc":"Struct representing a Claude Code hook configuration.\n\nThis struct is automatically encoded to JSON for the settings.json file.","ref":"Claude.Hooks.Hook.html"},{"type":"function","title":"Claude.Hooks.Hook.new/1","doc":"Creates a new hook configuration.","ref":"Claude.Hooks.Hook.html#new/1"},{"type":"type","title":"Claude.Hooks.Hook.t/0","doc":"","ref":"Claude.Hooks.Hook.html#t:t/0"},{"type":"behaviour","title":"Claude.Hooks.Hook.Behaviour","doc":"Behaviour for implementing Claude Code hooks.\n\nHooks must implement:\n- `config/0` to return their hook configuration as a %Claude.Hooks.Hook{} struct\n- `run/2` to execute the hook logic\n- `description/0` to provide a human-readable description","ref":"Claude.Hooks.Hook.Behaviour.html"},{"type":"callback","title":"Claude.Hooks.Hook.Behaviour.config/0","doc":"Returns the hook configuration as a %Claude.Hook{} struct.\n\nThis configuration will be automatically encoded to JSON and written\nto the settings.json file during installation.","ref":"Claude.Hooks.Hook.Behaviour.html#c:config/0"},{"type":"callback","title":"Claude.Hooks.Hook.Behaviour.description/0","doc":"Returns a human-readable description of what this hook does.","ref":"Claude.Hooks.Hook.Behaviour.html#c:description/0"},{"type":"callback","title":"Claude.Hooks.Hook.Behaviour.run/2","doc":"Executes the hook logic.","ref":"Claude.Hooks.Hook.Behaviour.html#c:run/2"},{"type":"callback","title":"Parameters - Claude.Hooks.Hook.Behaviour.run/2","doc":"- `event_type` - The type of event that triggered this hook (e.g., \"Write\", \"Edit\")\n- `file_path` - The path to the file being processed","ref":"Claude.Hooks.Hook.Behaviour.html#c:run/2-parameters"},{"type":"callback","title":"Return values - Claude.Hooks.Hook.Behaviour.run/2","doc":"- `:ok` - Hook executed successfully\n- `{:error, reason}` - Hook execution failed","ref":"Claude.Hooks.Hook.Behaviour.html#c:run/2-return-values"},{"type":"module","title":"Claude.Hooks.PostToolUse.CompilationChecker","doc":"Checks for compilation errors after Claude Code edits Elixir files.\n\nThis hook runs after Write, Edit, and MultiEdit operations on .ex and .exs files.","ref":"Claude.Hooks.PostToolUse.CompilationChecker.html"},{"type":"module","title":"Claude.Hooks.PostToolUse.ElixirFormatter","doc":"Checks if Elixir files need formatting after Claude Code edits them.\n\nThis hook runs after Write, Edit, and MultiEdit operations on .ex and .exs files,\nand alerts when formatting is needed without actually modifying the files.","ref":"Claude.Hooks.PostToolUse.ElixirFormatter.html"},{"type":"module","title":"Claude.Hooks.PreToolUse.PreCommitCheck","doc":"Pre-commit hook that validates formatting and compilation before allowing commits.\n\nThis hook runs before commit operations and blocks the commit if:\n- Any Elixir files are not properly formatted\n- The project has compilation errors or warnings","ref":"Claude.Hooks.PreToolUse.PreCommitCheck.html"},{"type":"module","title":"Claude.Utils.Shell","doc":"Shell output utilities for consistent CLI formatting.","ref":"Claude.Utils.Shell.html"},{"type":"function","title":"Claude.Utils.Shell.blank/0","doc":"Outputs a blank line.","ref":"Claude.Utils.Shell.html#blank/0"},{"type":"function","title":"Claude.Utils.Shell.bullet/1","doc":"Outputs a bullet point.","ref":"Claude.Utils.Shell.html#bullet/1"},{"type":"function","title":"Claude.Utils.Shell.error/1","doc":"Outputs an error message to stderr.","ref":"Claude.Utils.Shell.html#error/1"},{"type":"function","title":"Claude.Utils.Shell.info/1","doc":"Outputs an informational message.","ref":"Claude.Utils.Shell.html#info/1"},{"type":"function","title":"Claude.Utils.Shell.success/1","doc":"Outputs a success message with a checkmark.","ref":"Claude.Utils.Shell.html#success/1"},{"type":"function","title":"Claude.Utils.Shell.warn/1","doc":"Outputs a warning message.","ref":"Claude.Utils.Shell.html#warn/1"},{"type":"task","title":"mix claude","doc":"Entry point for Claude mix tasks.\nDelegates to the CLI module for command processing.\n\nClaude is an opinionated Claude Code integration for Elixir projects.","ref":"Mix.Tasks.Claude.html"},{"type":"task","title":"Usage - mix claude","doc":"mix claude   [subcommand] [options]","ref":"Mix.Tasks.Claude.html#module-usage"},{"type":"task","title":"Commands - mix claude","doc":"* `hooks` - Manage Claude Code hooks\n  * `help` - Show help information","ref":"Mix.Tasks.Claude.html#module-commands"},{"type":"task","title":"Examples - mix claude","doc":"mix claude hooks install\n    mix claude hooks uninstall\n    mix claude help\n\nFor detailed help on any command:\n\n    mix claude   help","ref":"Mix.Tasks.Claude.html#module-examples"},{"type":"function","title":"Mix.Tasks.Claude.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Claude.html#run/1"},{"type":"task","title":"mix claude.install","doc":"Convenience task to quickly install Claude hooks for your Elixir project.\n\nThis is equivalent to running:\n    mix claude hooks install","ref":"Mix.Tasks.Claude.Install.html"},{"type":"task","title":"Usage - mix claude.install","doc":"mix claude.install","ref":"Mix.Tasks.Claude.Install.html#module-usage"},{"type":"task","title":"What it does - mix claude.install","doc":"Installs all available Claude hooks including:\n- Auto-formatting for Elixir files after edits\n- Compilation checking to catch errors immediately\n\nFuture hooks will be automatically included when available.","ref":"Mix.Tasks.Claude.Install.html#module-what-it-does"},{"type":"function","title":"Mix.Tasks.Claude.Install.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Claude.Install.html#run/1"},{"type":"task","title":"mix claude.uninstall","doc":"Convenience task to quickly uninstall Claude hooks from your Elixir project.\n\nThis is equivalent to running:\n    mix claude hooks uninstall","ref":"Mix.Tasks.Claude.Uninstall.html"},{"type":"task","title":"Usage - mix claude.uninstall","doc":"mix claude.uninstall","ref":"Mix.Tasks.Claude.Uninstall.html#module-usage"},{"type":"task","title":"What it does - mix claude.uninstall","doc":"Removes all Claude-managed hooks while preserving any custom hooks\nyou may have added to your .claude/settings.json file.","ref":"Mix.Tasks.Claude.Uninstall.html#module-what-it-does"},{"type":"function","title":"Mix.Tasks.Claude.Uninstall.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Claude.Uninstall.html#run/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}